# std::not_equal_to

From cppreference.com
< cpp‎ | utility‎ | functional

Defined in header `<functional>` |  |
template< class T > struct not_equal_to; |  | (until C++14)
template< class T = void > struct not_equal_to; |  | (since C++14)

Function object for performing comparisons. Unless specialised, invokes operator!= on type `T`.

### Specializations

The standard library provides a specialization of `std::not_equal_to` when `T` is not specified, which leaves the parameter types and return type to be deduced.

not_equal_to<void> | function object implementing x != y deducing argument and return types (class template specialization)

(since C++14)

### Member types

Type | Definition
`result_type`(deprecated in C++17) | `bool`
`first_argument_type`(deprecated in C++17) | `T`
`second_argument_type`(deprecated in C++17) | `T`

(until C++20)

### Member functions

operator() | checks if the arguments are not equal (public member function)

## std::not_equal_to::operator()

bool operator()( const T& lhs, const T& rhs ) const; |  | (until C++14)
constexpr bool operator()( const T& lhs, const T& rhs ) const; |  | (since C++14)

Checks whether `lhs` is not equal to `rhs`.

### Parameters

lhs, rhs | - | values to compare

### Return value

true if lhs != rhs, false otherwise.

### Exceptions

(none)

### Possible implementation

    constexpr bool operator()(const T &lhs, const T &rhs) const
    {
        return lhs != rhs;
    }

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/utility/functional/not_equal_to&oldid=102525"